//------------------------------------------------------------------
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers    5
#property indicator_color1     clrLimeGreen
#property indicator_color2     clrPaleVioletRed
#property indicator_color3     clrLimeGreen
#property indicator_color4     clrPaleVioletRed
#property indicator_color5     clrDarkGray
#property indicator_width5     2
#property indicator_style3     STYLE_DOT
#property indicator_style4     STYLE_DOT
#property indicator_level1     0
#property indicator_levelcolor clrDarkGray

//
//
//
//
//

extern int                MaPeriod        = 20;
extern ENUM_MA_METHOD     MaMethod        = MODE_SMA;
extern ENUM_APPLIED_PRICE PriceToUse      = PRICE_TYPICAL;
extern int                AtrPeriod       = 50;
extern double             AtrMultiplier   = 2.5;
extern int                MaAtrShift      = 1;
extern bool               alertsOn        = true;
extern bool               alertsOnCurrent = true;
extern bool               alertsMessage   = true;
extern bool               alertsSound     = false;
extern bool               alertsNotify    = false;
extern bool               alertsEmail     = false;
extern string             soundFile       = "alert2.wav";
//
//
//
//
//

double bup[];
double bdn[];
double hup[];
double hdn[];
double price[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,hup); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,hdn); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,bup);
   SetIndexBuffer(3,bdn);
   SetIndexBuffer(4,price);
      IndicatorShortName("Keltner channel oscillator ("+MaPeriod+","+DoubleToStr(AtrMultiplier,1)+")");
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

      for(int i = limit; i >= 0; i--)
      {
         double tprice = iMA(NULL,0,1       ,0,MODE_SMA,PriceToUse,i+MaAtrShift);
         double ma     = iMA(NULL,0,MaPeriod,0,MaMethod,PriceToUse,i+MaAtrShift);
         double atr    = iATR(NULL,0,AtrPeriod,i+MaAtrShift);
            price[i] =  tprice-ma;
            bup[i]   =  AtrMultiplier*atr;
            bdn[i]   = -AtrMultiplier*atr;
            hup[i]   =  EMPTY_VALUE;
            hdn[i]   =  EMPTY_VALUE;
               if (price[i]>bup[i]) hup[i] = bup[i];
               if (price[i]<bdn[i]) hdn[i] = bdn[i];
      }
      
      //
      //
      //
      //
      //
      
      if (alertsOn)
      {
        if (alertsOnCurrent)
             int whichBar = 0;
        else     whichBar = 1; 
      
        //
        //
        //
        //
        //
      
        if (hup[whichBar+1] == EMPTY_VALUE && hup[whichBar] != EMPTY_VALUE) doAlert(whichBar,"crossed upper level");
        if (hdn[whichBar+1] == EMPTY_VALUE && hdn[whichBar] != EMPTY_VALUE) doAlert(whichBar,"crossed lower level");
      
     }         
return(0);
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Keltner channel oscillator  ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " Keltner channel oscillator "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}


